﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace _436233_TreeViewSample
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}

		private double CorrectOffset { get; set; }
		private bool MustPreserveCurrentOffset { get; set; }

		private void RadTreeView_SizeChanged(object sender, SizeChangedEventArgs e)
		{
			this.MustPreserveCurrentOffset = true;
			FixScroll(this.CorrectOffset);
		}

		private void radTreeView_ScrollChanged(object sender, ScrollChangedEventArgs e)
		{
			if (!MustPreserveCurrentOffset)
			{
				this.CorrectOffset = e.VerticalOffset;
			}
			else
			{
				FixScroll(this.CorrectOffset);
			}
			this.MustPreserveCurrentOffset = false;
		}

		private void FixScroll(double offset)
		{
			if (radTreeView.ScrollViewer.VerticalOffset != offset)
			{

				this.radTreeView.ScrollViewer.ScrollToVerticalOffset(offset);
			}
		}
	}
}
